'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ufunc = require('ufunc');

var _ufunc2 = _interopRequireDefault(_ufunc);

var _reactUikitBase = require('react-uikit-base');

var _reactUikitBase2 = _interopRequireDefault(_reactUikitBase);

var _cuid = require('cuid');

var _cuid2 = _interopRequireDefault(_cuid);

var _trigger = require('../../react-uikit-trigger/lib/trigger');

var _trigger2 = _interopRequireDefault(_trigger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = (function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Dropdown).call(this, props));

    _this.dataId = (0, _cuid2.default)();
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'handleTriggerClick',
    value: function handleTriggerClick(e) {
      e.preventDefault();
      var props = this.props;

      console.log(e.currentTarget);

      var dropbody = _reactUikitBase2.default.helpers.queryData('dropbody-' + props.kitid);

      if (!props.opened) {
        props.trigger.animate.in(dropbody);
      } else {
        props.trigger.animate.out(dropbody);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var props = this.props;
      var kitid = _ufunc2.default.either(props.kitid, 'this.dataId')(props.kitid);

      // CSS classes
      var cssClassNames = _reactUikitBase2.default.helpers.cleanClasses([props.classes, props.className]);

      // Elements

      // Return Component
      return _react2.default.createElement(
        'div',
        {
          className: cssClassNames,
          'data-kitid': 'dropdown-' + kitid
        },
        _react2.default.createElement(_trigger2.default, _extends({}, props.trigger, {
          onTriggerClick: props.click ? function (e) {
            return _this2.handleTriggerClick(e);
          } : function () {},
          kitid: kitid
        })),
        _react2.default.createElement(
          'div',
          {
            'data-kitid': 'dropbody-' + kitid,
            className: 'uk-dropdown'
          },
          props.children
        )
      );
    }
  }]);

  return Dropdown;
})(_react2.default.Component);

Dropdown.propTypes = {
  children: _react2.default.PropTypes.any,
  className: _react2.default.PropTypes.string,
  classes: _react2.default.PropTypes.array,
  context: _react2.default.PropTypes.oneOf(['dropdown', 'offcanvas', 'side', 'sub']),
  items: _react2.default.PropTypes.array,
  kitid: _react2.default.PropTypes.string,
  parent: _react2.default.PropTypes.bool,
  type: _react2.default.PropTypes.oneOf(['bar', 'dropdown', 'offcanvas', 'side', 'sub', 'thumbnail'])
};
;

exports.default = _reactUikitBase2.default.base(Dropdown);