'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ufunc = require('ufunc');

var _ufunc2 = _interopRequireDefault(_ufunc);

var _reactUikitBase = require('react-uikit-base');

var _reactUikitBase2 = _interopRequireDefault(_reactUikitBase);

var _reactUikitButton = require('react-uikit-button');

var _reactUikitButton2 = _interopRequireDefault(_reactUikitButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Trigger = function Trigger(props) {
  var icon = _ufunc2.default.maybeIf(_react2.default.createElement('i', { className: 'uk-icon-' + props.icon }))(props.icon);

  var cleanProps = _reactUikitBase2.default.helpers.cleanProps(['icon'])(props);
  var cleanPropType = _reactUikitBase2.default.helpers.cleanProps(['type'])(props);

  var cssClassNames = _reactUikitBase2.default.helpers.cleanClasses([props.classes, props.className]);

  var type = {
    button: _react2.default.createElement(
      _reactUikitButton2.default,
      _extends({}, props, cleanProps, {
        className: cssClassNames,
        block: true,
        kitid: props.kitid,
        body: props.body
      }),
      props.children,
      ' ',
      icon
    ),

    link: _react2.default.createElement(
      _reactUikitButton2.default,
      _extends({}, props, cleanProps, cleanPropType, {
        className: cssClassNames,
        block: true,
        kitid: props.kitid,
        type: 'link',
        body: props.body
      }),
      props.children,
      ' ',
      icon
    ),

    span: _react2.default.createElement(
      'span',
      _extends({}, props, cleanProps, cleanPropType, _reactUikitBase2.default.helpers.events, {
        className: cssClassNames,
        'data-kitid': props.kitid
      }),
      props.body,
      props.children,
      ' ',
      icon
    ),

    div: _react2.default.createElement(
      'div',
      _extends({}, props, cleanProps, cleanPropType, {
        className: cssClassNames
      }, _reactUikitBase2.default.helpers.events, {
        'data-kitid': props.kitid
      }),
      props.body,
      props.children,
      ' ',
      icon
    )
  };

  return _ufunc2.default.either(type[props.type], type['button'])(props.type);
};

Trigger.propTypes = {
  body: _react2.default.PropTypes.any,
  children: _react2.default.PropTypes.any,
  className: _react2.default.PropTypes.string,
  classes: _react2.default.PropTypes.array,
  kitid: _react2.default.PropTypes.string,
  onClick: _react2.default.PropTypes.func,
  opened: _react2.default.PropTypes.bool,
  type: _react2.default.PropTypes.oneOf(['button', 'link', 'span', 'div'])
};

exports.default = _reactUikitBase2.default.base(Trigger);